package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.WFUserGroup;
import com.sa.ibiz.demo.demo.domain.WFUser;

/**
 * 实体[WFUserGroupDetail] 数据对象
 */
@TableName(value = "T_SRFWFUSERGROUPDETAIL",resultMap = "WFUserGroupDetailResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WFUserGroupDetail extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFUserGroup wfusergroup;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFUser wfuser;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String memo;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @TableId(value= "wfusergroupdetailid",type=IdType.UUID)//指定主键生成策略
    private String wfusergroupdetailid;
    private String wfusergroupdetailname;
    private String wfusergroupid;
    @TableField(exist = false)//逻辑属性
    private String wfusergroupname;
    private String wfuserid;
    @TableField(exist = false)//逻辑属性
    private String wfusername;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[工作流用户组成员标识]
     *  @param wfusergroupdetailid
     */
    public void setWfusergroupdetailid(String wfusergroupdetailid){
        if(StringUtils.isEmpty(wfusergroupdetailid))
            wfusergroupdetailid=null;
        this.wfusergroupdetailid = wfusergroupdetailid;
        this.set("wfusergroupdetailiddirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户组成员标识]
     */
    public String getWfusergroupdetailid(){
        return this.wfusergroupdetailid;
    }
    /**
     *  重置属性值[工作流用户组成员标识]
     */
    public void resetWfusergroupdetailid(){
        this.set("wfusergroupdetailiddirtyflag",false);
        this.wfusergroupdetailid = null;
    }
    /**
     *  设置属性值[工作流用户名称]
     *  @param wfusergroupdetailname
     */
    public void setWfusergroupdetailname(String wfusergroupdetailname){
        if(StringUtils.isEmpty(wfusergroupdetailname))
            wfusergroupdetailname=null;
        this.wfusergroupdetailname = wfusergroupdetailname;
        this.set("wfusergroupdetailnamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户名称]
     */
    public String getWfusergroupdetailname(){
        return this.wfusergroupdetailname;
    }
    /**
     *  重置属性值[工作流用户名称]
     */
    public void resetWfusergroupdetailname(){
        this.set("wfusergroupdetailnamedirtyflag",false);
        this.wfusergroupdetailname = null;
    }
    /**
     *  设置属性值[用户组]
     *  @param wfusergroupid
     */
    public void setWfusergroupid(String wfusergroupid){
        if(StringUtils.isEmpty(wfusergroupid))
            wfusergroupid=null;
        this.wfusergroupid = wfusergroupid;
        this.set("wfusergroupiddirtyflag",true);
    }
    /**
     *  获取属性值[用户组]
     */
    public String getWfusergroupid(){
        return this.wfusergroupid;
    }
    /**
     *  重置属性值[用户组]
     */
    public void resetWfusergroupid(){
        this.set("wfusergroupiddirtyflag",false);
        this.wfusergroupid = null;
    }
    /**
     *  设置属性值[工作流用户组]
     *  @param wfusergroupname
     */
    public void setWfusergroupname(String wfusergroupname){
        if(StringUtils.isEmpty(wfusergroupname))
            wfusergroupname=null;
        this.wfusergroupname = wfusergroupname;
        this.set("wfusergroupnamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户组]
     */
    public String getWfusergroupname(){
        return this.wfusergroupname;
    }
    /**
     *  重置属性值[工作流用户组]
     */
    public void resetWfusergroupname(){
        this.set("wfusergroupnamedirtyflag",false);
        this.wfusergroupname = null;
    }
    /**
     *  设置属性值[用户]
     *  @param wfuserid
     */
    public void setWfuserid(String wfuserid){
        if(StringUtils.isEmpty(wfuserid))
            wfuserid=null;
        this.wfuserid = wfuserid;
        this.set("wfuseriddirtyflag",true);
    }
    /**
     *  获取属性值[用户]
     */
    public String getWfuserid(){
        return this.wfuserid;
    }
    /**
     *  重置属性值[用户]
     */
    public void resetWfuserid(){
        this.set("wfuseriddirtyflag",false);
        this.wfuserid = null;
    }
    /**
     *  设置属性值[工作流用户]
     *  @param wfusername
     */
    public void setWfusername(String wfusername){
        if(StringUtils.isEmpty(wfusername))
            wfusername=null;
        this.wfusername = wfusername;
        this.set("wfusernamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户]
     */
    public String getWfusername(){
        return this.wfusername;
    }
    /**
     *  重置属性值[工作流用户]
     */
    public void resetWfusername(){
        this.set("wfusernamedirtyflag",false);
        this.wfusername = null;
    }
     /**
     *  获取主实体关联数据[WFUserGroup]
     */
    public WFUserGroup getWfusergroup() {
        return wfusergroup;
    }
    /**
     *  设置主实体关联数据[WFUserGroup]
     */
    public void setWfusergroup(WFUserGroup wfusergroup) {
        this.wfusergroup = wfusergroup;
    }

     /**
     *  获取主实体关联数据[WFUser]
     */
    public WFUser getWfuser() {
        return wfuser;
    }
    /**
     *  设置主实体关联数据[WFUser]
     */
    public void setWfuser(WFUser wfuser) {
        this.wfuser = wfuser;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetMemo();
        resetUpdatedate();
        resetUpdateman();
        resetWfusergroupdetailid();
        resetWfusergroupdetailname();
        resetWfusergroupid();
        resetWfusergroupname();
        resetWfuserid();
        resetWfusername();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
    	//联合主键
        String primaryKey ="";
        primaryKey+=this.getWfusergroupid();
        primaryKey+="||";
        primaryKey+=this.getWfuserid();
        return  DigestUtils.md5DigestAsHex(primaryKey.getBytes());
    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WFUserGroupDetail copyTo(WFUserGroupDetail targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WFUserGroupDetail.class, WFUserGroupDetail.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWfusergroupdetailid();
		return targetEntity;
	}
}